<template>
  <a-modal
    v-model:visible="props.visible"
    :title="props.levelId ? '编辑' : '新增'"
    width="500px"
    @cancel="dialogClose"
  >
    <a-form
      class="ls-form"
      ref="formRef"
      :model="formData"
      :label-col="{ style: { width: '85px' } }"
    >
      <a-form-item
        label="职级名称"
        name="name"
        :rules="{ required: true, message: '请输入职级名称', trigger: 'blur' }"
      >
        <a-input v-model:value="formData.name" placeholder="请输入职级名称" allow-clear />
      </a-form-item>
      <a-form-item label="职级状态" name="code">
        <a-radio-group v-model:value="formData.status" name="status">
          <a-radio :value="1">正常</a-radio>
          <a-radio :value="2">停用</a-radio>
        </a-radio-group>
      </a-form-item>
      <a-form-item label="排序" name="sort">
        <a-input-number v-model:value="formData.sort" />
      </a-form-item>
    </a-form>
    <template #footer>
      <span class="dialog-footer">
        <a-button @click="dialogClose">取消</a-button>
        <a-button :loading="subLoading" type="primary" @click="submit"> 确定 </a-button>
      </span>
    </template>
  </a-modal>
</template>
<script lang="ts" setup>
  import type { FormInstance } from 'ant-design-vue';
  import { getLevelDetail, levelAdd, levelUpdate } from '@/api/system/level';
  import { onMounted, reactive, shallowRef } from 'vue';
  import { message } from 'ant-design-vue';
  import { useLockFn } from '@/utils/useLockFn';

  const emit = defineEmits(['success', 'update:visible']);
  const formRef = shallowRef<FormInstance>();

  /**
   * 定义表单参数
   */
  const formData = reactive({
    id: '',
    name: '',
    status: 1,
    sort: 0,
  });

  /**
   * 定义接收的参数
   */
  const props = defineProps({
    visible: {
      type: Boolean,
      required: true,
      default: false,
    },
    levelId: {
      type: Number,
      required: true,
      default: 0,
    },
  });

  /**
   * 执行提交
   */
  const handleSubmit = async () => {
    await formRef.value?.validate();
    props.levelId ? await levelUpdate(formData) : await levelAdd(formData);
    message.success('操作成功');
    emit('update:visible', false);
    emit('success');
  };

  /**
   * 关闭窗体
   */
  const dialogClose = () => {
    emit('update:visible', false);
  };

  const { isLock: subLoading, lockFn: submit } = useLockFn(handleSubmit);

  /**
   * 设置表单数据
   */
  const setFormData = async () => {
    const data = await getLevelDetail(props.levelId);
    for (const key in formData) {
      if (data[key] != null && data[key] != undefined) {
        //@ts-ignore
        formData[key] = data[key];
      }
    }
  };

  /**
   * 钩子函数
   */
  onMounted(() => {
    if (props.levelId) {
      setFormData();
    }
  });
</script>
